<?php
define('PHPGW_INCLUDE_ROOT','../');
define('PHPGW_API_INC','../phpgwapi/inc');	
include_once(PHPGW_API_INC.'/class.common.inc.php');

class ldap_functions
{
	var $ldap;
	var $current_config;
	
	function ldap_functions(){
		$GLOBALS['phpgw_info']['server'] = $_SESSION['phpgw_info']['expresso']['server'];
		$this->current_config = $_SESSION['phpgw_info']['expresso']['expressoAdmin'];
		$common = new common();
		$this->ldap = $common->ldapConnect();
	}
	
	function validate_fields($params)
	{
		$params = unserialize($params['attributes']);
		$type = $params['type'];
		$context = $GLOBALS['phpgw_info']['server']['ldap_context'];
		$uid = $params['uid'];
		$mail = $params['mail'];
		$mailalternateaddress = $params['mailalternateaddress'];

		$result['status'] = true;
		
		if ($_SESSION['phpgw_info']['expresso']['global_denied_users'][$uid])
		{
			$result['status'] = false;
			$result['msg'] = 'Este LOGIN no pode ser usado pois  uma conta de sistema.';
			return $result;
		}
		
		if (($type == 'create_user') || ($type == 'rename_user')) 
		{
			// UID
			$filter = "(&(|(phpgwAccountType=u)(phpgwAccountType=l))(uid=$uid))";
			$justthese = array("uid");
			$search = ldap_search($this->ldap, $context, $filter, $justthese);
			$count_entries = ldap_count_entries($this->ldap,$search);
			if ($count_entries > 0)
			{
				$result['status'] = false;
				$result['msg'] = 'LOGIN j esta sendo usado.';
				return $result;
			}

			// GRUPOS
			$filter = "(&(phpgwAccountType=g)(cn=$uid))";
			$justthese = array("cn");
			$search = ldap_search($this->ldap, $context, $filter, $justthese);
			$count_entries = ldap_count_entries($this->ldap,$search);
			if ($count_entries > 0)
			{
				$result['status'] = false;
				$result['msg'] = 'LOGIN do usurio j esta sendo usado por um grupo.';
				return $result;
			}
		
			// UID em outras organizaes
			//Quando tento retirar as organizaes pelo expressoAdmin d este erro.
			$filter = "(ou=*)";
			$justthese = array("ou");
			$search = ldap_list($this->ldap, $context, $filter, $justthese);
			$entries = ldap_get_entries($this->ldap,$search);
			foreach ($entries as $index=>$org)
			{
				$organization = $org['ou'][0];
				$organization = strtolower($organization);
				
				$filter = "(&(|(phpgwAccountType=u)(phpgwAccountType=l))(uid=$organization-$uid))";
				$justthese = array("uid");
				$search = ldap_search($this->ldap, $context, $filter, $justthese);
				$count_entries = ldap_count_entries($this->ldap,$search);
				if ($count_entries > 0)
				{
					$result['status'] = false;
					$result['msg'] = 'LOGIN j esta sendo usado por outro usurio em outra organizao.';
					return $result;
				}
			}
		}
		
		if ($type == 'rename_user')
		{
			return $result;
		}
		
		// MAIL
		$filter = "(&(|(phpgwAccountType=u)(phpgwAccountType=l))(|(mail=$mail)(mailalternateaddress=$mail)))";
		$justthese = array("mail", "uid");
		$search = ldap_search($this->ldap, $context, $filter, $justthese);
		$entries = ldap_get_entries($this->ldap,$search);
		if ($entries['count'] == 1){
			if ($entries[0]['uid'][0] != $uid){
				$result['status'] = false;
				$result['msg'] = 'E-MAIL est sendo usado por 1 usurio: ' . $entries[0]['uid'][0];
				//ldap_close($this->ldap);
				return $result;
			}
		}
		else if ($entries['count'] > 1){
			$result['status'] = false;
			$result['msg'] = 'E-MAIL est sendo usado por de 2 ou mais usurios.';
			//ldap_close($this->ldap);
			return $result;
		}
		
		// MAILAlternateAddress
		$filter = "(&(|(phpgwAccountType=u)(phpgwAccountType=l))(|(mail=$mailalternateaddress)(mailalternateaddress=$mailalternateaddress)))";
		$justthese = array("mail", "uid");
		$search = ldap_search($this->ldap, $context, $filter, $justthese);
		$entries = ldap_get_entries($this->ldap,$search);
		if ($entries['count'] == 1){
			if ($entries[0]['uid'][0] != $uid){
				$result['status'] = false;
				$result['msg'] = "E-MAIL alternativo est sendo usado por 1 usurio: " . $entries[0]['uid'][0];
				//ldap_close($this->ldap);
				return $result;
			}
		}
		else if ($entries['count'] > 1){
			$result['status'] = false;
			$result['msg'] = 'E-MAIL alternativo est sendo usado por 2 ou mais usurios.';
			return $result;
		}

		return $result;
	}
	
	function validate_fields_group($params)
	{
		$context = $GLOBALS['phpgw_info']['server']['ldap_context'];
		$cn = $params['cn'];
		$result['status'] = true;
		
		if ($_SESSION['phpgw_info']['expresso']['global_denied_groups'][$cn])
		{
			$result['status'] = false;
			$result['msg'] = 'Este nome de grupo no pode ser usado pois  um grupo de sistema.';
			return $result;
		}
		
		// CN
		$filter = "(&(phpgwAccountType=g)(cn=$cn))";
		$justthese = array("cn");
		$search = ldap_search($this->ldap, $context, $filter, $justthese);
		$count_entries = ldap_count_entries($this->ldap,$search);
		if ($count_entries > 0)
		{
			$result['status'] = false;
			$result['msg'] = 'NOME do grupo j est sendo usado.';
			return $result;
		}
		
		// UID
		$filter = "(&(|(phpgwAccountType=u)(phpgwAccountType=l))(uid=$cn))";
		$justthese = array("uid");
		$search = ldap_search($this->ldap, $context, $filter, $justthese);
		$count_entries = ldap_count_entries($this->ldap,$search);
		if ($count_entries > 0)
		{
			$result['status'] = false;
			$result['msg'] = 'NOME do grupo j esta sendo usado por um usurio.';
			return $result;
		}
		
		return $result;	
	}
	
	function validate_fields_maillist($params)
	{
		$context = $GLOBALS['phpgw_info']['server']['ldap_context'];
		$uid = $params['uid'];
		$mail = $params['mail'];
		$result['status'] = true;
		
		if ($_SESSION['phpgw_info']['expresso']['global_denied_users'][$uid])
		{
			$result['status'] = false;
			$result['msg'] = 'Este LOGIN no pode ser usado pois  uma conta de sistema.';
			return $result;
		}
		
		// UID
		$filter = "(&(phpgwAccountType=l)(uid=$uid))";
		$justthese = array("uid");
		$search = ldap_search($this->ldap, $context, $filter, $justthese);
		$count_entries = ldap_count_entries($this->ldap,$search);
		if ($count_entries > 0)
		{
			$result['status'] = false;
			$result['msg'] = 'LOGIN da lista j est sendo usado.';
			return $result;
		}
		
		// MAIL
		/*
		$filter = "(&(|(phpgwAccountType=u)(phpgwAccountType=l))(|(mail=$mail)(mailalternateaddress=$mail)))";
		$justthese = array("mail");
		$search = ldap_search($this->ldap, $context, $filter, $justthese);
		$count_entries = ldap_count_entries($this->ldap,$search);
		if ($count_entries > 0)
		{
			$result['status'] = false;
			$result['msg'] = 'E-MAIL da lista j est sendo usado.';
			return $result;
		}*/
		
		return $result;	
	}

	//Busca usurios de um contexto e j retorna as options do select;
	function get_available_users($params)
	{
		$context = $params['context'];
		$recursive = $params['recursive'];
		$justthese = array("cn", "uidNumber");
		$filter="(phpgwAccountType=u)";
		
		if ($recursive == 'true')
			$groups_list=ldap_search($this->ldap, $context, $filter, $justthese);
		else
    		$groups_list=ldap_list($this->ldap, $context, $filter, $justthese);
    	
    	$entries = ldap_get_entries($this->ldap, $groups_list);
    	
		for ($i=0; $i<$entries["count"]; $i++){
			$u_tmp[$entries[$i]["uidnumber"][0]] = $entries[$i]["cn"][0];
		}
			
		if (count($u_tmp))
			natcasesort($u_tmp);

		$i = 0;
		$users = array();
			
		if (count($u_tmp))
		{
			foreach ($u_tmp as $uidnumber => $cn)
			{
				$options .= "<option value=$uidnumber>$cn</option>";
			}
			unset($u_tmp);
		}

    	return $options;
	}

	//Busca usurios de um contexto e j retorna as options do select;
	/*
	function get_available_users_and_maillist($params)
	{
		$context = $params['context'];
		$recursive = $params['recursive'];
		$justthese = array("cn", "uidNumber");
		$filter="(|(phpgwAccountType=u)(phpgwAccountType=l))";
		
		if ($recursive == 'true')
			$groups_list=ldap_search($this->ldap, $context, $filter, $justthese);
		else
    		$groups_list=ldap_list($this->ldap, $context, $filter, $justthese);
    	
    	$entries = ldap_get_entries($this->ldap, $groups_list);
    	
		for ($i=0; $i<$entries["count"]; $i++){
			$u_tmp[$entries[$i]["uidnumber"][0]] = $entries[$i]["cn"][0];
		}
			
		if (count($u_tmp))
			natcasesort($u_tmp);

		$i = 0;
		$users = array();
			
		if (count($u_tmp))
		{
			foreach ($u_tmp as $uidnumber => $cn)
			{
				$options .= "<option value=$uidnumber>$cn</option>";
			}
			unset($u_tmp);
		}

    	return $options;
	}
	*/

	//Busca usurios e listas de um contexto e j retorna as options do select;
	function get_available_users_and_maillist($params)
	{
		$context = $params['context'];
		$recursive = $params['recursive'];
		
		//Usado para retirar a prpria lista das possibilidades de incluso.
		$denied_uidnumber = $params['denied_uidnumber'];
		
		$justthese = array("cn", "uidNumber");
		$users_filter="(&(phpgwAccountType=u)(!(phpgwAccountVisible=-1)))";
		$lists_filter = $denied_uidnumber == '' ? "(phpgwAccountType=l)" : "(&(phpgwAccountType=l)(!(uidnumber=$denied_uidnumber)))";
		
		$users = Array();
		$lists = Array();		

		if ($recursive == 'true')
		{
			$lists_search = ldap_search($this->ldap, $context, $lists_filter, $justthese);
			$users_search = ldap_search($this->ldap, $context, $users_filter, $justthese);
		}
		else
		{
			$lists_search = ldap_list($this->ldap, $context, $lists_filter, $justthese);
			$users_search = ldap_list($this->ldap, $context, $users_filter, $justthese);
		}
		
		$lists_entries = ldap_get_entries($this->ldap, $lists_search);
		for ($i=0; $i<$lists_entries["count"]; $i++)
		{
			$l_tmp[$lists_entries[$i]["uidnumber"][0]] = $lists_entries[$i]["cn"][0];
		}
			
		if (count($l_tmp))
			natcasesort($l_tmp);
			
		$i = 0;
		$lists = array();
		
		$options .= '<option  value="-1" disabled>------------------------------&nbsp;&nbsp;&nbsp;&nbsp;Listas&nbsp;&nbsp;&nbsp;&nbsp;------------------------------ </option>'."\n";	
		if (count($l_tmp))
		{
			foreach ($l_tmp as $uidnumber => $cn)
			{
				$options .= "<option value=$uidnumber>$cn</option>";
			}
			unset($l_tmp);
		}
		
		$users_entries = ldap_get_entries($this->ldap, $users_search);
		for ($i=0; $i<$users_entries["count"]; $i++)
		{
			$u_tmp[$users_entries[$i]["uidnumber"][0]] = $users_entries[$i]["cn"][0];
		}
			
		if (count($u_tmp))
			natcasesort($u_tmp);
			
		$i = 0;
		$users = array();
		
		$options .= '<option  value="-1" disabled>-----------------------------&nbsp;&nbsp;&nbsp;&nbsp;Usurios&nbsp;&nbsp;&nbsp;&nbsp;---------------------------- </option>'."\n";	
		if (count($u_tmp))
		{
			foreach ($u_tmp as $uidnumber => $cn)
			{
				$options .= "<option value=$uidnumber class='line-above'>$cn</option>";
			}
			unset($u_tmp);
		}
			
   		return $options;
	}

	function get_available_groups($params)
	{
		$context = $params['context'];
		$justthese = array("cn", "gidNumber");
    	$groups_list=ldap_list($this->ldap, $context, ("(phpgwAccountType=g)"), $justthese);
    	ldap_sort($this->ldap, $groups_list, "cn");
    	
    	$entries = ldap_get_entries($this->ldap, $groups_list);
    	return $entries;		
	}
	
	function get_available_maillists($params)
	{
		$context = $params['context'];
		$justthese = array("uid","mail","uidNumber");
    	$maillists=ldap_list($this->ldap, $context, ("(phpgwAccountType=l)"), $justthese);
    	ldap_sort($this->ldap, $maillists, "uid");
    	
    	$entries = ldap_get_entries($this->ldap, $maillists);
    	return $entries;		
	}
	
	function ldap_add_entry($dn, $entry)
	{
		$result = array();
		if (!@ldap_add ( $this->ldap, $dn, $entry ))
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->ldap_add_entry ($dn).\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		else
			$result['status'] = true;
		
		return $result;
	}
	
	function ldap_save_photo($dn, $pathphoto, $photo_exist=false)
	{
		$fd = fopen($pathphoto, "r");
		$fsize = filesize($pathphoto);
		$jpegStr = fread($fd, $fsize);
		fclose ($fd);
		$attrs['jpegPhoto'] = $jpegStr;
			
		if ($photo_exist)
			$res = @ldap_mod_replace($this->ldap, $dn, $attrs);
		else
			$res = @ldap_mod_add($this->ldap, $dn, $attrs);
			
		if ($res)
		{
			$result['status'] = true;
		}
		else
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->ldap_save_photo ($dn).\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		
		return $result;
	}
	
	function ldap_remove_photo($dn)
	{
		$attrs['jpegPhoto'] = array();
		$res = ldap_mod_del($this->ldap, $dn, $attrs);
		
		if ($res)
		{
			$result['status'] = true;
		}
		else
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->ldap_remove_photo ($dn).\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		
		return $result;
	}	
	
	// Pode receber tanto um nico memberUid quanto um array de memberUid's
	function add_user2group($gidNumber, $memberUid)
	{
		$filter = "(&(phpgwAccountType=g)(gidNumber=$gidNumber))";
		$justthese = array("dn");
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
		$entry = ldap_get_entries($this->ldap, $search);
		$group_dn = $entry[0]['dn'];
		$attrs['memberUid'] = $memberUid;
		
		$res = @ldap_mod_add($this->ldap, $group_dn, $attrs);
		
		if ($res)
		{
			$result['status'] = true;
		}
		else
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->add_user2group ($memberUid).\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		return $result;
	}
	
	function remove_user2group($gidNumber, $memberUid)
	{
		$filter = "(&(phpgwAccountType=g)(gidNumber=$gidNumber))";
		$justthese = array("dn");
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
		$entry = ldap_get_entries($this->ldap, $search);
		$group_dn = $entry[0]['dn'];
		$attrs['memberUid'] = $memberUid;
		$res = @ldap_mod_del($this->ldap, $group_dn, $attrs);
		
		/*echo 'usuarios recebidos para remocao no ldap';
		echo '<pre>';
		print_r($memberUid);*/
		
		if ($res)
		{
			$result['status'] = true;
		}
		else
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->remove_user2group ($memberUid).\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		return $result;
	}
	
	function add_user2maillist($uidNumber, $mail)
	{
		$filter = "(&(phpgwAccountType=l)(uidNumber=$uidNumber))";
		$justthese = array("dn");
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
		$entry = ldap_get_entries($this->ldap, $search);
		$group_dn = $entry[0]['dn'];
		$attrs['mailForwardingAddress'] = $mail;
		$res = @ldap_mod_add($this->ldap, $group_dn, $attrs);
		
		if ($res)
		{
			$result['status'] = true;
		}
		else
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->add_user2maillist ($mail).\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		return $result;
	}
	
	function add_user2maillist_scl($dn, $array_emails)
	{
		$attrs['mailSenderAddress'] = $array_emails;
		$res = @ldap_mod_add($this->ldap, $dn, $attrs);
		
		if ($res)
		{
			$result['status'] = true;
		}
		else
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->add_user2maillist_scp ($dn).\n\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		return $result;
	}

	function remove_user2maillist($uidNumber, $mail)
	{
		$filter = "(&(phpgwAccountType=l)(uidNumber=$uidNumber))";
		$justthese = array("dn");
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
		$entry = ldap_get_entries($this->ldap, $search);
		$group_dn = $entry[0]['dn'];
		$attrs['mailForwardingAddress'] = $mail;
		$res = @ldap_mod_del($this->ldap, $group_dn, $attrs);
		
		if ($res)
		{
			$result['status'] = true;
		}
		else
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->remove_user2maillist ($mail).\n\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		return $result;
	}

	function remove_user2maillist_scl($dn, $array_emails)
	{
		$attrs['mailSenderAddress'] = $array_emails;
		$res = @ldap_mod_del($this->ldap, $dn, $attrs);
		
		if ($res)
		{
			$result['status'] = true;
		}
		else
		{
			$result['status'] = false;
			$result['msg'] = "Erro na funcao ldap_functions->remove_user2maillist_scp ($dn).\n\nRetorno do servidor:" . ldap_error($this->ldap);
		}
		return $result;
	}

	function replace_user2maillists($new_mail, $old_mail)
	{
		$filter = "(&(phpgwAccountType=l)(mailforwardingaddress=$old_mail))";
		$justthese = array("dn");
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
		$entries = ldap_get_entries($this->ldap, $search);
		$result['status'] = true;
		for ($i=0; $i<$entries['count']; $i++)
		{
			$attrs['mailforwardingaddress'] = $old_mail;
			$res1 = @ldap_mod_del($this->ldap, $entries[$i]['dn'], $attrs);
			$attrs['mailforwardingaddress'] = $new_mail;
			$res2 = @ldap_mod_add($this->ldap, $entries[$i]['dn'], $attrs);
		
			if ((!$res1) || (!$res2))
			{
				$result['status'] = false;
				$result['msg'] = "Erro na funcao ldap_functions->replace_user2maillists ($old_mail).\nRetorno do servidor:" . ldap_error($this->ldap);
			}
		}
		
		return $result;
	}
	
	function get_user_info($uidnumber, $context)
	{
		$filter="(&(phpgwAccountType=u)(uidNumber=".$uidnumber."))";
		$search = ldap_search($this->ldap, $context, $filter);
		$entry = ldap_get_entries($this->ldap, $search);

		//Pega o dn do setor do usuario.
		$entry[0]['dn'] = strtolower($entry[0]['dn']);
		$sector_dn_array = explode(",", $entry[0]['dn']);
		for($i=1; $i<count($sector_dn_array); $i++)
			$sector_dn .= $sector_dn_array[$i] . ',';
		//Retira ultimo pipe.
		$sector_dn = substr($sector_dn,0,(strlen($sector_dn) - 1));
		
		$result['context']				= $sector_dn;
		$result['uid']					= $entry[0]['uid'][0];
		$result['uidnumber']			= $entry[0]['uidnumber'][0];
		$result['gidnumber']			= $entry[0]['gidnumber'][0];
		$result['departmentnumber']		= $entry[0]['departmentnumber'][0];
		$result['givenname']			= $entry[0]['givenname'][0];
		$result['sn']					= $entry[0]['sn'][0];
		$result['telephonenumber']		= $entry[0]['telephonenumber'][0];
		$result['phpgwaccountstatus']	= $entry[0]['phpgwaccountstatus'][0];
		$result['phpgwaccountvisible']	= $entry[0]['phpgwaccountvisible'][0];
		$result['accountstatus']		= $entry[0]['accountstatus'][0];
		$result['mail']					= $entry[0]['mail'][0];
		$result['mailalternateaddress']	= $entry[0]['mailalternateaddress'][0];
		$result['mailforwardingaddress']= $entry[0]['mailforwardingaddress'][0];
		$result['deliverymode']			= $entry[0]['deliverymode'][0];

		//Photo
		if ($entry[0]['jpegphoto']['count'] == 1)
			$result['photo_exist'] = 'true';
		
		// Samba
		for ($i=0; $i<$entry[0]['objectclass']['count']; $i++)
		{
			if ($entry[0]['objectclass'][$i] == 'sambaSamAccount')
				$result['sambaUser'] = true;
		}		 
		if (($this->current_config['expressoAdmin_samba_support'] == 'true') && ($result['sambaUser']))
		{
			$result['sambaaccflags'] = $entry[0]['sambaacctflags'][0];
			$result['sambalogonscript'] = $entry[0]['sambalogonscript'][0];
			$result['homedirectory'] = $entry[0]['homedirectory'][0];
		}
		
		// MailLists
		$justthese = array("uid","mail","uidnumber");
		$filter="(&(phpgwAccountType=l)(mailforwardingaddress=".$result['mail']."))";
		$search = ldap_search($this->ldap, $context, $filter, $justthese);
    	ldap_sort($this->ldap, $search, "uid");
    	$entries = ldap_get_entries($this->ldap, $search);
    	for ($i=0; $i<$entries['count']; $i++)
    	{
    		$result['maillists_info'][$i]['uidnumber'] = $entries[$i]['uidnumber'][0];
    		$result['maillists_info'][$i]['uid'] = $entries[$i]['uid'][0];
    		$result['maillists_info'][$i]['mail'] = $entries[$i]['mail'][0];
    		$result['maillists'][] = $entries[$i]['uidnumber'][0];
    	}
    	
    	// Groups
		$justthese = array("gidnumber","cn");
		$filter="(&(phpgwAccountType=g)(memberuid=".$result['uid']."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
    	ldap_sort($this->ldap, $search, "cn");
    	$entries = ldap_get_entries($this->ldap, $search);
    	for ($i=0; $i<$entries['count']; $i++)
    	{
    		$result['groups_ldap'][ $entries[$i]['gidnumber'][0] ] = $entries[$i]['cn'][0];
    	}
    	
		return $result;		
	}
	
	function get_group_info($gidnumber, $context)
	{
		$filter="(&(phpgwAccountType=g)(gidNumber=".$gidnumber."))";
		$search = ldap_search($this->ldap, $context, $filter);
		$entry = ldap_get_entries($this->ldap, $search);

		//Pega o dn do setor do grupo.
		$entry[0]['dn'] = strtolower($entry[0]['dn']);
		$sector_dn_array = explode(",", $entry[0]['dn']);
		for($i=1; $i<count($sector_dn_array); $i++)
			$sector_dn .= $sector_dn_array[$i] . ',';
		//Retira ultimo pipe.
		$sector_dn = substr($sector_dn,0,(strlen($sector_dn) - 1));
		
		$result['context']				= $sector_dn;
		$result['cn']					= $entry[0]['cn'][0];
		$result['description']			= $entry[0]['description'][0];
		$result['gidnumber']			= $entry[0]['gidnumber'][0];
		$result['phpgwaccountvisible']	= $entry[0]['phpgwaccountvisible'][0];
		
		//MemberUid
		for ($i=0; $i<$entry[0]['memberuid']['count']; $i++)
		{
			$justthese = array("cn","uid","uidnumber");
			
			// Montagem dinamica do filtro
			$filter="(&(phpgwAccountType=u)(|";
			for ($k=0; (($k<10) && ($i<$entry[0]['memberuid']['count'])); $k++)
			{
				$filter .= "(uid=".$entry[0]['memberuid'][$i].")";
				$i++;
			}
			$i--;
			$filter .= "))";
			
			$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
			$user_entry = ldap_get_entries($this->ldap, $search);

			for ($j=0; $j<$user_entry['count']; $j++)
			{
				$result['memberuid_info'][$user_entry[$j]['uid'][0]]['cn'] = $user_entry[$j]['cn'][0];
				$result['memberuid_info'][$user_entry[$j]['uid'][0]]['uidnumber'] = $user_entry[$j]['uidnumber'][0];
				$result['memberuid_info'][$user_entry[$j]['uid'][0]]['type'] = 'u';
			}
		}
		
		// Retira o count do array
		array_shift($entry[0]['memberuid']);
		
		// Checamos e-mails que no fazem parte do expresso.
		// Criamos um array temporario
		$tmp_array = array();
		foreach ($result['memberuid_info'] as $uid => $user_data)
		{
			$tmp_array[] = $uid;
		}

		// Vemos a diferena
		$array_diff = array_diff($entry[0]['memberuid'], $tmp_array);
		
		// Incluimos no resultado
		foreach ($array_diff as $index=>$uid)
		{
			$result['memberuid_info'][$uid]['cn'] = $uid;
		}
		
		// Samba
		for ($i=0; $i<$entry[0]['objectclass']['count']; $i++)
		{
			if ($entry[0]['objectclass'][$i] == 'sambaGroupMapping')
				$result['sambaGroup'] = true;
		}

		return $result;
	}	
	
	function get_maillist_info($uidnumber, $context)
	{
		$filter="(&(phpgwAccountType=l)(uidNumber=".$uidnumber."))";
		$search = ldap_search($this->ldap, $context, $filter);
		$entry = ldap_get_entries($this->ldap, $search);
	
		//Pega o dn do setor do usuario.
		$entry[0]['dn'] = strtolower($entry[0]['dn']);
		$sector_dn_array = explode(",", $entry[0]['dn']);
		for($i=1; $i<count($sector_dn_array); $i++)
			$sector_dn .= $sector_dn_array[$i] . ',';
		//Retira ultimo pipe.
		$sector_dn = substr($sector_dn,0,(strlen($sector_dn) - 1));
			
		$result['context']				= $sector_dn;
		$result['uidnumber']			= $entry[0]['uidnumber'][0];
		$result['uid']					= $entry[0]['uid'][0];
		$result['cn']					= $entry[0]['cn'][0];
		$result['mail']					= $entry[0]['mail'][0];
		$result['accountStatus']		= $entry[0]['accountstatus'][0];
		$result['phpgwAccountVisible']	= $entry[0]['phpgwaccountvisible'][0];
			
		//Members
		for ($i=0; $i<$entry[0]['mailforwardingaddress']['count']; $i++)
		{
			$justthese = array("cn", "uidnumber", "uid", "phpgwaccounttype", "mail");
				
			// Montagem dinamica do filtro
			$filter="(&(|(phpgwAccountType=u)(phpgwAccountType=l))(|";
			for ($k=0; (($k<10) && ($i<$entry[0]['mailforwardingaddress']['count'])); $k++)
			{
				$filter .= "(mail=".$entry[0]['mailforwardingaddress'][$i].")";
				$i++;
			}
			$i--;
			$filter .= "))";
				
			$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
			$user_entry = ldap_get_entries($this->ldap, $search);
				
			for ($j=0; $j<$user_entry['count']; $j++)
			{
				$result['members_info'][$user_entry[$j]['uidnumber'][0]]['uid'] = $user_entry[$j]['uid'][0];
				$result['members_info'][$user_entry[$j]['uidnumber'][0]]['cn'] = $user_entry[$j]['cn'][0];
				$result['members_info'][$user_entry[$j]['uidnumber'][0]]['type'] = $user_entry[$j]['phpgwaccounttype'][0];
				$result['members_info'][$user_entry[$j]['uidnumber'][0]]['mail'] = $user_entry[$j]['mail'][0];
				$result['members'][] = $user_entry[$j]['uidnumber'][0];
			}
		}

		// Retira o count do array
		array_shift($entry[0]['mailforwardingaddress']);

		// Checamos e-mails que no fazem parte do expresso.
		// Criamos um array temporario
		$tmp_array = array();
		foreach ($result['members_info'] as $uid => $user_data)
		{
			$tmp_array[] = $user_data['mail'];
		}

		// Vemos a diferena
		$array_diff = array_diff($entry[0]['mailforwardingaddress'], $tmp_array);

		// Incluimos no resultado
		foreach ($array_diff as $index=>$mailforwardingaddress)
		{
			$result['members_info'][$mailforwardingaddress]['uid'] = $mailforwardingaddress;
			$result['members_info'][$mailforwardingaddress]['cn'] = 'E-Mail nao encontrado';
			$result['members_info'][$mailforwardingaddress]['mailforwardingaddress'] = $mailforwardingaddress;
			$result['members'][] = $mailforwardingaddress;
		}
		return $result;	
	}	

	function get_maillist_scl_info($uidnumber, $context)
	{
		$filter="(&(phpgwAccountType=l)(uidNumber=".$uidnumber."))";
		$search = ldap_search($this->ldap, $context, $filter);
		$entry = ldap_get_entries($this->ldap, $search);

		//Pega o dn do setor do usuario.
		$entry[0]['dn'] = strtolower($entry[0]['dn']);
		$sector_dn_array = explode(",", $entry[0]['dn']);
		for($i=1; $i<count($sector_dn_array); $i++)
			$sector_dn .= $sector_dn_array[$i] . ',';
		//Retira ultimo pipe.
		$sector_dn = substr($sector_dn,0,(strlen($sector_dn) - 1));
		
		$result['dn']						= $entry[0]['dn'];
		$result['context']					= $sector_dn;
		$result['uidnumber']				= $entry[0]['uidnumber'][0];
		$result['uid']						= $entry[0]['uid'][0];
		$result['cn']						= $entry[0]['cn'][0];
		$result['mail']						= $entry[0]['mail'][0];
		$result['accountStatus']			= $entry[0]['accountstatus'][0];
		$result['phpgwAccountVisible']		= $entry[0]['phpgwaccountvisible'][0];
		$result['accountRestrictive']		= $entry[0]['accountrestrictive'][0];
		$result['participantCanSendMail']	= $entry[0]['participantcansendmail'][0];
		
		//Senders
		for ($i=0; $i<$entry[0]['mailsenderaddress']['count']; $i++)
		{
			$justthese = array("cn", "uidnumber", "uid", "mail");
			$filter="(&(phpgwAccountType=u)(mail=".$entry[0]['mailsenderaddress'][$i]."))";
			$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
			$user_entry = ldap_get_entries($this->ldap, $search);
			
			$result['senders_info'][$user_entry[0]['uidnumber'][0]]['uid'] = $user_entry[0]['uid'][0];
			$result['senders_info'][$user_entry[0]['uidnumber'][0]]['cn'] = $user_entry[0]['cn'][0];
			$result['senders_info'][$user_entry[0]['uidnumber'][0]]['mail'] = $user_entry[0]['mail'][0];
			$result['members'][] = $user_entry[0]['uidnumber'][0];
		}

		return $result;
	}	

	function group_exist($gidnumber)
	{
		$justthese = array("cn");
		$filter="(&(phpgwAccountType=g)(gidNumber=".$gidnumber."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
				
		$entry = ldap_get_entries($this->ldap, $search);
		if ($entry['count'] == 0)
			return false;
		else
			return true;
	}

	function gidnumbers2cn($gidnumbers, $context)
	{
		if (count($gidnumbers))
		{
			$justthese = array("cn");
			$i = 0;
			foreach ($gidnumbers as $gidnumber)
			{
				$filter="(&(phpgwAccountType=g)(gidNumber=".$gidnumber."))";
				$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
				
				$entry = ldap_get_entries($this->ldap, $search);
				if ($entry['count'] == 0)
					$result['groups_info'][$i]['cn'] = '_Grupo existe no BD mas no no LDAP';
				else
					$result['groups_info'][$i]['cn'] = $entry[0]['cn'][0];
				$result['groups_info'][$i]['gidnumber'] = $gidnumber;
				
				if (!strpos(strtolower($entry[0]['dn']), strtolower($context)))
					$result['groups_info'][$i]['group_disabled'] = 'true';
				else
					$result['groups_info'][$i]['group_disabled'] = 'false';
				
				$i++;
			}
		}
		return $result;
	}

	function uidnumber2uid($uidnumber)
	{
		$justthese = array("uid");
		$filter="(&(|(phpgwAccountType=u)(phpgwAccountType=l))(uidNumber=".$uidnumber."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
		$entry = ldap_get_entries($this->ldap, $search);
		return $entry[0]['uid'][0];
	}

	function uidnumber2mail($uidnumber)
	{
		$justthese = array("mail");
		$filter="(&(|(phpgwAccountType=u)(phpgwAccountType=l))(uidNumber=".$uidnumber."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
		$entry = ldap_get_entries($this->ldap, $search);
		return $entry[0]['mail'][0];
	}

	
	function change_user_context($dn, $newrdn, $newparent)
	{
		if (!ldap_rename ( $this->ldap, $dn, $newrdn, $newparent, true ))
		{
			$return['status'] = false;
			$return['msg'] = 'Erro em ldap_funcitons->change_user_context: ' . ldap_error($this->ldap);
		}
		else
			$return['status'] = true;
		
		return $return;
	}
	
	function replace_user_attributes($dn, $ldap_mod_replace)
	{
		if (!@ldap_mod_replace ( $this->ldap, $dn, $ldap_mod_replace ))
		{
			$return['status'] = false;
			$return['msg'] = 'Erro em ldap_funcitons->replace_user_attributes: ' . ldap_error($this->ldap);
		}
		else
			$return['status'] = true;
		
		return $return;
	}
	
	function add_user_attributes($dn, $ldap_add)
	{
		if (!@ldap_mod_add ( $this->ldap, $dn, $ldap_add ))
		{
			$return['status'] = false;
			$return['msg'] = 'Erro em ldap_funcitons->add_user_attributes: ' . ldap_error($this->ldap);
		}
		else
			$return['status'] = true;
		
		return $return;
	}
	
	function remove_user_attributes($dn, $ldap_remove)
	{
		if (!@ldap_mod_del ( $this->ldap, $dn, $ldap_remove ))
		{
			$return['status'] = false;
			$return['msg'] = 'Erro em ldap_funcitons->remove_user_attributes: ' . ldap_error($this->ldap);
		}
		else
			$return['status'] = true;
		
		return $return;
	}
	
	function set_user_password($uid, $password)
	{
		$justthese = array("userPassword");
		$filter="(&(phpgwAccountType=u)(uid=".$uid."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
	    $entry = ldap_get_entries($this->ldap, $search);
		$dn = $entry[0]['dn'];
		$userPassword = $entry[0]['userpassword'][0];
		$ldap_mod_replace['userPassword'] = $password;
		$this->replace_user_attributes($dn, $ldap_mod_replace);
		return $userPassword;
	}
	
	function delete_user($user_info)
	{
		$return['status'] = true;
		
		// GROUPS
		$attrs = array();
		$attrs['memberUid'] = $user_info['uid'];
		if (count($user_info['groups_info']))
		{
			foreach ($user_info['groups_info'] as $group_info)
			{
				$gidnumber = $group_info['gidnumber'];
				$justthese = array("dn");
				$filter="(&(phpgwAccountType=g)(gidnumber=".$gidnumber."))";
				$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
	    		$entry = ldap_get_entries($this->ldap, $search);
				$dn = $entry[0]['dn'];
			
				if (!@ldap_mod_del($this->ldap, $dn, $attrs))
				{
					$return['status'] = false;
					$return['msg'] .= 'Erro em ldap_funcitons->delete_user, grupos: ' . ldap_error($this->ldap);
				}
			}
		}
			
		// MAILLISTS
		$attrs = array();
		$attrs['mailForwardingAddress'] = $user_info['mail'];
		if (count($user_info['maillists_info']))
		{
			foreach ($user_info['maillists_info'] as $maillists_info)
			{
				$uidnumber = $maillists_info['uidnumber'];
				$justthese = array("dn");
				$filter="(&(phpgwAccountType=l)(uidnumber=".$uidnumber."))";
				$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
	    		$entry = ldap_get_entries($this->ldap, $search);
				$dn = $entry[0]['dn'];
			
				if (!@ldap_mod_del($this->ldap, $dn, $attrs))
				{
					$return['status'] = false;
					$return['msg'] .= 'Erro em ldap_funcitons->delete_user, listas de email: ' . ldap_error($this->ldap);
				}
			}
		}
			
		// UID
		$dn = "uid=" . $user_info['uid'] . "," . $user_info['context'];
		if (!@ldap_delete($this->ldap, $dn))
		{
			$return['status'] = false;
			$return['msg'] .= 'Erro em ldap_funcitons->delete_user, listas de email: ' . ldap_error($this->ldap);
		}
		
		return $return;
	}
	
	function delete_maillist($uidnumber)
	{
		$return['status'] = true;
		
		$justthese = array("dn");
		$filter="(&(phpgwAccountType=l)(uidnumber=".$uidnumber."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
   		$entry = ldap_get_entries($this->ldap, $search);
		$dn = $entry[0]['dn'];
		
		if (!@ldap_delete($this->ldap, $dn))
		{
			$return['status'] = false;
			$return['msg'] .= 'Erro em ldap_funcitons->delete_maillist, listas de email: ' . ldap_error($this->ldap);
		}
		
		return $return;
	}

	function delete_group($gidnumber)
	{
		$return['status'] = true;
		
		$justthese = array("dn");
		$filter="(&(phpgwAccountType=g)(gidnumber=".$gidnumber."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
   		$entry = ldap_get_entries($this->ldap, $search);
		$dn = $entry[0]['dn'];
		
		if (!@ldap_delete($this->ldap, $dn))
		{
			$return['status'] = false;
			$return['msg'] .= 'Erro em ldap_funcitons->delete_maillist, listas de email: ' . ldap_error($this->ldap);
		}
		
		return $return;
	}

	
	function rename_uid($uid, $new_uid)
	{
		$return['status'] = true;
		
		$justthese = array("dn");
		$filter="(&(phpgwAccountType=u)(uid=".$uid."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
	    $entry = ldap_get_entries($this->ldap, $search);
		$dn = $entry[0]['dn'];
		
		$explode_dn = ldap_explode_dn($dn, 0);
		$rdn = "uid=" . $new_uid;

		$parent = array();
		for ($j=1; $j<(count($explode_dn)-1); $j++)
			$parent[] = $explode_dn[$j];
		$parent = implode(",", $parent);
		
		$return['new_dn'] = $rdn . ',' . $parent;
			
		if (!@ldap_rename($this->ldap, $dn, $rdn, $parent, false))
		{
			$return['status'] = false;
			$return['msg'] .= 'Erro em ldap_funcitons->rename_uid: ' . ldap_error($this->ldap);
		}
		
		//Grupos
		$justthese = array("dn");
		$filter="(&(phpgwAccountType=g)(memberuid=".$uid."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
	    $entry = ldap_get_entries($this->ldap, $search);
    	$array_mod_add['memberUid'] = $new_uid;
    	$array_mod_del['memberUid'] = $uid;

	    for ($i=0; $i<=$entry['count']; $i++)
	    {
	    	$dn = $entry[$i]['dn'];
	    	@ldap_mod_add ( $this->ldap, $dn,  $array_mod_add);
	    	@ldap_mod_del ( $this->ldap, $dn,  $array_mod_del);
	    }
		return $return;
	}

	function rename_cn($cn, $new_cn)
	{
		$return['status'] = true;
		
		$justthese = array("dn");
		$filter="(&(phpgwAccountType=g)(uid=".$cn."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
	    $entry = ldap_get_entries($this->ldap, $search);
		$dn = $entry[0]['dn'];
		
		$explode_dn = ldap_explode_dn($dn, 0);
		$rdn = "cn=" . $new_cn;

		$parent = array();
		for ($j=1; $j<(count($explode_dn)-1); $j++)
			$parent[] = $explode_dn[$j];
		$parent = implode(",", $parent);
		
		$return['new_dn'] = $rdn . ',' . $parent;
			
		if (!@ldap_rename($this->ldap, $dn, $rdn, $parent, false))
		{
			$return['status'] = false;
		}
		
		return $return;
	}

	function rename_departmentnumber($old_dp, $new_dp)
	{
		
		$return['status'] = true;
		
		
		$justthese = array("dn");
		$filter="(&(phpgwAccountType=u)(departmentnumber=".$old_dp."))";
		$search = ldap_search($this->ldap, $GLOBALS['phpgw_info']['server']['ldap_context'], $filter, $justthese);
	    $entry = ldap_get_entries($this->ldap, $search);
		
	    for ($i=0; $i<=$entry['count']; $i++)
	    {
	    	$dn = strtolower($entry[$i]['dn']);
	    	$ldap_mod_replace = array();
	    	$ldap_mod_replace['departmentnumber'] = $new_dp;
	    	@ldap_mod_replace ( $this->ldap, $dn,  $ldap_mod_replace);
			/*if (!@ldap_mod_replace ( $this->ldap, $dn,  $ldap_mod_replace))
			{
				$return['status'] = false;
				$return['msg'] .= 'Erro em ldap_funcitons->rename_departmentnumber: ' . ldap_error($this->ldap);
			}*/
	    }
		return $return;
	}
}
?>